/*
const RateJson = {
    "apiVersion": 2,
    "name": "pmrates/rate-dynamic",
    "title": "Pannos: Rate Table",
    "category": "text",
    "description": "Display a Rate Table.",
    "attributes": {
        "rateTableID": {
            "type": "string",
            "default": ""
        },
        "showIcon": {
            "type": "string",
            "default": "no"
        },
        "rateTableAnchor": {
            "type": "string",
            "default": ""
        },
        "rateTableMargin": {
            "type": "string",
            "default": "margin-bottom-large"
        }
    },
    "supports": {
        "customClassName": false
    }
};

wp.blocks.registerBlockType( RateJson, {

    edit: (props) => {
        var blockProps = wp.blockEditor.useBlockProps({
            className: 'wp-block-pmrates-selector',
        });

        let content = props.attributes.content;
        let rateTableID = props.attributes.rateTableID;
        let rateTableMargin = props.attributes.rateTableMargin;
        let rateTableAnchor = props.attributes.rateTableAnchor;
        let showIcon = props.attributes.showIcon;

        var posts = wp.data.useSelect( function ( select ) {
            // Have to specify per_page because otherwise max is 10 records.
            return select( 'core' ).getEntityRecords( 'postType', 'pmrates_rate', { per_page: 100, orderby: 'title', order: 'asc' } );
        }, [] );

        if ( ! posts ) {
            content = 'Loading...';
        } else if ( posts.length === 0 ) {
            content = 'No posts';
        } else {
            let tableIdOps = new Array({label: '-- Select Rate --', value: ''});
            posts.forEach(function(post) {
                tableIdOps.push({label: post.title.rendered, value: post.id});
            });

            let showIconOps = new Array(
                {label: 'No', value: 'no'},
                {label: 'Yes', value: 'yes'},
            );

            let blockMarginOps = new Array(
                {label: 'Large', value: 'margin-bottom-large'},
                {label: 'Medium', value: 'margin-bottom-medium'},
                {label: 'Small', value: 'margin-bottom-small'},
                {label: 'None', value: 'margin-bottom-none'}
            );

            content = wp.element.createElement(
                'div',
                blockProps,
                [
                    tableBlockTitle = wp.element.createElement(
                        'p',
                        {
                            className: "pmrates-block-title"
                        },
                        'Display a Rate Table'
                    ),

                    tableIdSelector = wp.element.createElement(
                        wp.components.SelectControl,
                        {
                            value: rateTableID,
                            label: "Select Rate Table",
                            options: tableIdOps,
                            onChange: function( value ) {
                                // Set the current value
                                props.setAttributes({ rateTableID: value});
                            }
                        }
                    ),

                    tableMarginSelector = wp.element.createElement(
                        wp.components.SelectControl,
                        {
                            value: rateTableMargin,
                            label: "Block Margin",
                            options: blockMarginOps,
                            onChange: function( value ) {
                                // Set the current value
                                props.setAttributes({ rateTableMargin: value});
                            }
                        }
                    ),

                    showIconSelector = wp.element.createElement(
                        wp.components.SelectControl,
                        {
                            value: showIcon,
                            label: "Show Icon",
                            options: showIconOps,
                            onChange: function( value ) {
                                // Set the current value
                                props.setAttributes({ showIcon: value});
                            }
                        }
                    ),

                    tableAnchorSelector = wp.element.createElement(
                        wp.components.TextControl,
                        {
                            value: rateTableAnchor,
                            label: "HTML Anchor (Optional)",
                            onChange: function( value ) {
                                // Set the current value
                                props.setAttributes({ rateTableAnchor: value});
                            }
                        }
                    )
                ]
            )
        }

        return content;
    },
    save: function() {
        return null;
    }
});

*/