<?php

if (!function_exists('showRateTableMarkup')) {
    function showRateTableMarkup($rateTableJSON, $rateTableCaption, $hide_columns, $hide_rows, $rate_table_id) {
        $tableCells = array();
        if(isset($rateTableJSON) && !empty($rateTableJSON)) {
            $tableCells = preg_split("/::celldivide::/", html_entity_decode($rateTableJSON, ENT_QUOTES));
            foreach ($tableCells as $i => $cell) {
                $tableCells[$i] = json_decode($cell, true);
            }
        }

        $tableHTML = "<table class='editableTable '><caption class='visuallyhidden'>".$rateTableCaption."</caption><tbody><tr class=\"row_0";
        if(isset($hide_rows[0]) && $hide_rows[0]) $tableHTML .= ' hidden';
        $tableHTML .= "\">";
        $lastRow = -1;
        $prev_row = -1;
        $firstRow = true;
        $countRow = 1;
        $countCell = 0;
        $headerValues = array();
        $table_layout = array();


        $searchTerm = "::quote::";
        $searchReplacement = "'";

        foreach ($tableCells as $i => $cell) {
            $hidden_row = '';
            $hidden_cell = '';
            if ($lastRow != $cell["RowNumeric"]) {
                if ($lastRow != -1) {
                    if(isset($hide_rows[$countRow]) && $hide_rows[$countRow]) { 
                        $tableHTML .= "</tr>
                            <tr class=\"row_".$countRow."_evenodd hidden\">
                                <td colspan=\"".$countCell."\"></td>
                            </tr>
                            <tr class=\"row_".$countRow." hidden\">";
                    } else $tableHTML .= "</tr><tr class=\"row_".$countRow."\">";
                    $countRow++;
                    $countCell = 0;
                    $firstRow = false;
                }
                $prev_row = $lastRow;
                $lastRow = $cell["RowNumeric"];
                $table_layout[$lastRow] = array();
            }            
            if(isset($hide_columns[$countCell]) && $hide_columns[$countCell]) { $hidden_cell = ' hidden'; }

            $cellvalue = html_entity_decode($cell["CellValue"], ENT_QUOTES);
            $cellContent = str_replace($searchTerm, $searchReplacement, $cellvalue);

            if ($firstRow) {
                $cell_header_id = preg_replace('#[^\w.%\&]#',"_",strip_tags(strtolower($cellContent))).'_'.$rate_table_id;
                $tableHTML .= "<th class=\"cell_".$countCell.$hidden_cell."\" id='".$cell_header_id."'>" . $cellContent . "</th>";
                array_push($headerValues, $cell["CellValue"]);
            } else {
                if(is_null($cellContent)) $cellContent = '';

                if(stristr($cellContent, '[ditto]')){
                    $cellContent = '<span class="mobile-ditto" style="display:none;">'.$table_layout[$prev_row][$countCell].'</span>';
                }

                $cellHeaders = trim(strip_tags(str_replace(array('<sup>','</sup>','&nbsp;'), array('(',')',''), do_shortcode($headerValues[intval($cell["ColNumeric"])]))));

                $cell_header_id = preg_replace('#[^\w.%\&]#',"_",strip_tags(strtolower($headerValues[intval($cell["ColNumeric"])]))).'_'.$rate_table_id;

                // $cellHeaders = $headerValues[intval($cell["ColNumeric"])];
                if(empty($cellHeaders) || $cellHeaders == '&nbsp'){ $data_title = ''; } else { $data_title = "data-title-enabled data-title='" . $cellHeaders . "'"; }
                $tableHTML .= "<td class=\"cell_".$countCell.$hidden_cell."\" headers='".$cell_header_id."' " . $data_title . ">" . $cellContent . "</td>";
            }      
            $table_layout[$lastRow][$countCell] = $cellContent;
            $countCell ++;
        }
        $tableHTML .= "</tr></body></table>";

        return $tableHTML;
    }
}

if (!function_exists('getRateTableCellData')) {
    function getRateTableCellData($rateTableJSON, $rowId, $cellId) {
        $tableCells = array();
        if(isset($rateTableJSON) && !empty($rowId) && isset($rowId) && !empty($rateTableJSON) && isset($cellId) && !empty($cellId)) {
            $tableCells = preg_split("/::celldivide::/", html_entity_decode($rateTableJSON, ENT_QUOTES));
            foreach ($tableCells as $i => $cell) {
                $tableCells[$i] = json_decode($cell, true);
                if(intval($rowId) == intval($tableCells[$i]["RowID"]) && intval($cellId) == intval($tableCells[$i]["ColID"])) {
                    return $tableCells[$i]["CellValue"];
                }
            }
        }
        return '';
    }
}
?>
