var editPMRATES = document.querySelector(".pmrates-control-area");
if(editPMRATES) {
    function pmAddRow() {
        var target = document.querySelector(".pmRateTable");
        var newRow = target.insertRow(target.rows.length - 1);
        var cols = document.getElementById('pmRateTable').rows[0].cells;
        var row = "";
        var rowid = Math.floor(Math.random() * 9999999);
        for (var i = 0; i < cols.length - 1; i++) {
            var newCell = newRow.insertCell(-1);
            var cellBuild = "<input type='text' value='' />";
            newCell.innerHTML = cellBuild;
            newCell.dataset["rowid"] = rowid;
            newCell.dataset["colid"] = cols[i].dataset.colid;
        }
        var finalCell = newRow.insertCell(-1)
        finalCell.innerHTML = "<button class='pmRateTable-delete-row' type='button'>&times;</button><button class='pmRateTable-move-up' type='button'>&uarr;</button><button class='pmRateTable-move-down' type='button'>&darr;</button>";
    };

    function pmAddCol() {
        var rows = document.getElementById('pmRateTable').rows;
        var colid = Math.floor(Math.random() * 9999999);
        for (var i = 0; i < rows.length; i++) {
            var rw = rows[i].insertCell(rows[i].cells.length - 1);
            rw.dataset["rowid"] = rows[i].cells[0].dataset.rowid;
            rw.dataset["colid"] = colid;
            var cellBuild = "<input type='text' value='' />";
            rw.innerHTML = cellBuild;
            if (i == rows.length - 1) {
                rw.innerHTML = "<button class='pmRateTable-delete-col' type='button'>&times;</button><button class='pmRateTable-move-left' type='button'>&larr;</button><button class='pmRateTable-move-right' type='button'>&rarr;</button>";
            }
        }
    };
    var editorCreated = false;
    var currentElementWithFocus;

    //Edit HTML of Cell
    function pmEditCell() {
        if (currentElementWithFocus != null) {
            wp.editor.remove('pmRateTable-edit-ta');
            wp.editor.initialize('pmRateTable-edit-ta', {
              tinymce: true,
              quicktags: true
            });

            var activeEditor = tinyMCE.get('pmRateTable-edit-ta');

            if(activeEditor.getContent()){
                // if editor has content, replace it immediately
                activeEditor.setContent(currentElementWithFocus.value);
            } else {
                // if editor has no content, give it a second to initialize before setting it
                setTimeout(function() {
                    activeEditor.setContent(currentElementWithFocus.value);
                }, 750);
            }
            

            document.querySelector(".pmRateTable-edit-modal").style.display = "flex";
        }
    };

    function pmDeleteRow(elem) {

    }

    // Function to update the CTA listing text labels
    function updateListingText(elem) {
        title = elem.value == undefined ? "" : elem.value;
        elem.parentElement.querySelector('.table-cta-list-text').innerText = title;
    }

    // On load set the CTA titles.
    let ctaTitles = document.querySelectorAll('.table-cta-text');
    for (var i = 0; i < ctaTitles.length; i++) {
        updateListingText(ctaTitles[i]);
    }

    // Function for when Ranges change value to show the numerical percent.
    function showValIndicator(elem, value) {
        elem.parentElement.querySelector(".overlay-opacity-indicator").innerText = parseInt(parseFloat(value) * 100);
    }

    // On load make them calculate themselves.
    let ranges = document.querySelectorAll('input[type="range"].pmrates-range-control');
    for (var i = 0; i < ranges.length; i++) {
        showValIndicator(ranges[i], ranges[i].value);
    }

    function orderCTAs() {
        let ctaList = document.querySelectorAll('#table-cta-container li');
        for(i = 0; i < ctaList.length; i++) {
            ctaList[i].querySelector('.table-cta-list-number').innerText = (i + 1);
        }
    }

    // Order the CTAs on load.
    orderCTAs();

    // Add a new CTA row.
    function pmAddCTA() {
        var target = document.getElementById('pmrates-cta-container');
        var newCTA = document.createElement('li');
        ctaHTML = '<p>CTA <span class="table-cta-list-number">' + (document.querySelectorAll('#table-cta-container li').length + 1) + '</span> - <span class="table-cta-list-text"></span><button class="pmrates-delete-cta" type="button">&times;</button><button class="pmrates-move-cta-up" type="button">&uarr;</button><button class="pmrates-move-cta-down" type="button">&darr;</button></p><input type="text" class="pmrates-cta-text table-cta-text" placeholder="CTA Text" onchange="updateListingText(this)" oninput="updateListingText(this)" /><input type="text" class="pmrates-cta-ada-text table-cta-ada-text" placeholder="CTA ADA Text" /><select class="pmrates-cta-url table-cta-url"><option value="">-- Select a Page --</option>';
        pageList = document.getElementById("pmrates-page-list-json").innerText.trim().split("::pagedivide::");
        for (var i = 0; i < pageList.length-1; i++) {
            
            let pageData = JSON.parse(pageList[i].trim());
            ctaHTML += '<option value="' + pageData[0].id + '">' + pageData[0].title + '</option>';
        }
        ctaHTML += '</select><input type="text" class="pmrates-cta-anchor" placeholder="Optional Anchor for Page Links" value="" pattern="#[A-Za-z0-9\\-_]+" /><input type="text" class="pmrates-cta-custom-url table-cta-custom-url" placeholder="Custom URL (Overrides Page Selection)" /><select class="pmrates-cta-target table-cta-target"><option value="_self">Open Link in the Same Tab</option><option value="_blank">Open Link in the New Tab</option></select><input type="text" class="pmrates-cta-custom-class table-cta-custom-class" placeholder="Custom Class" />';
        newCTA.innerHTML = ctaHTML;
        target.appendChild(newCTA);
    };

    // Refresh content of input preview

    function refreshPreview(container) {
        var input = document.getElementById(container+'text').value;
        document.getElementById(container+'prev').innerHTML = input;
    }


    function cellFocus(cell) {
        var thecell = document.getElementById(cell);
        thecell.focus();
        console.log(thecell);
    }

    (function (window) {
        window.htmlentities = {
            /**
             * Converts a string to its html characters completely.
             *
             * @param {String} str String with unescaped HTML characters
             **/
            encode: function (str) {
                var buf = [];

                for (var i = str.length - 1; i >= 0; i--) {
                    buf.unshift(['&#', str[i].charCodeAt(), ';'].join(''));
                }

                return buf.join('');
            },
            /**
             * Converts an html characterSet into its original character.
             *
             * @param {String} str htmlSet entities
             **/
            decode: function (str) {
                return str.replace(/&#(\d+);/g, function (match, dec) {
                    return String.fromCharCode(dec);
                });
            }
        };

    })(window);

    function pmSaveTable() {
        const TABLEID = document.getElementById("post_ID").value;
        // Retrieve the table data
        var td_build = [];
        var td_headers = [];
        var cells = document.getElementById('pmRateTable').rows;
        //Iterate through Rows
        for (var i = 0; i < cells.length - 1; i++) {
            //Iterate through Cells and create json
            for (var j = 0; j < cells[i].cells.length - 1; j++) {
                var inps = cells[i].cells[j].querySelectorAll("input[type=text]");
                inps.forEach(function (inp) {
                    if(i === 0) {
                        td_headers.push(htmlentities.encode(inp.value.trim().toLowerCase().replaceAll(/\s{1,}/ig , '_').replaceAll(/[^\w]/ig, '').replaceAll(/_{2,}/ig , '_').replace(/"/g, "::quote::").replace(/&quot;/g, "::quote::") + "_" + TABLEID.toString()));
                    }
                    td_build.push('{"RowID":"' + cells[i].cells[j].dataset.rowid + '","RowNumeric":"' + i + '","ColID":"' + cells[i].cells[j].dataset.colid + '","ColNumeric": "' + j + '","CellValue":"' + htmlentities.encode(inp.value.replace(/"/g, "::quote::").replace(/&quot;/g, "::quote::")) + '","CellHeaders": "' + td_headers[j] + '"}');
                });
            }
        }

        // Build all of the value together and save as string value
        full_table_build = td_build.join("::celldivide::");
        document.getElementById('table_data').value = full_table_build;

        // Retrieve the cta data
        let cta_build = [];
        let ctas = document.querySelectorAll('#pmrates-cta-container > li');
        //Iterate through LIs and create json
        for (var i = 0; i < ctas.length; i++) {
            // Pull each of the values from the LI
            let cta_text = htmlentities.encode(ctas[i].querySelector('.pmrates-cta-text').value.replace(/"/g, "::quote::").replace(/&quot;/g, "::quote::"));
            let cta_ada_text = htmlentities.encode(ctas[i].querySelector('.pmrates-cta-ada-text').value.replace(/"/g, "::quote::").replace(/&quot;/g, "::quote::"));
            let cta_url = encodeURI(ctas[i].querySelector('.pmrates-cta-url').value);
            let cta_anchor = ctas[i].querySelector('.pmrates-cta-anchor').value;
            let cta_custom_url = ctas[i].querySelector('.pmrates-cta-custom-url').value;
            let cta_custom_class = ctas[i].querySelector('.pmrates-cta-custom-class').value;
            let cta_target = ctas[i].querySelector('.pmrates-cta-target').value;

            // Cat them together with an easily identifiable separator
            cta_build.push('{"text":"' + cta_text + '", "ada_text":"' + cta_ada_text + '", "url":"' + cta_url + '", "anchor":"' + cta_anchor + '", "custom_url":"' + cta_custom_url + '", "target":"' + cta_target + '" , "custom_class":"' + cta_custom_class + '"}');
        }

        // Build all of the value together and save as string value
        let full_build = cta_build.join("::ctadivide::");
        document.getElementById('cta_data').value = full_build;

        return true;
    };

    // Set table to save anytime you focus out of a input
    document.addEventListener('blur', (event) => {
        return pmSaveTable();
    }, true);

    // On focus of input inside of the table
    document.addEventListener('focus', (event) => {
        // Check nodeName to prevent error -- #document doesn't have a matches method.
        if(event.target.nodeName !== "#document") {
            if(event.target.matches("tr input")) {
                currentElementWithFocus = event.target;
                var sc = document.querySelector(".js-pmRateTable-sc");
                var tableId = document.querySelector("#pmRateTable-id");
                sc.innerHTML = "[pmrates tableId="+tableId.value+" cellId="+event.target.parentNode.getAttribute("data-colid")+" rowId="+event.target.parentNode.getAttribute("data-rowid")+"]";
            } else {
                return;
            }
        }
    }, true);

    //Modal Editor Buttons
    document.addEventListener('click', event => {
        if (event.target.matches('.pmRateTable-modal-update')) {
            event.preventDefault();
            currentElementWithFocus.value = wp.editor.getContent('pmRateTable-edit-ta');
            document.querySelector(".pmRateTable-edit-modal").style.display = "none";

        }
        else if (event.target.matches('.pmRateTable-modal-cancel')) {
            event.preventDefault();
            document.querySelector(".pmRateTable-edit-modal").style.display = "none";
        }
        else {
            return;
        }
    }, true);


    //Set onclick of delete button for row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-delete-row')) {
            return;
        }
        event.preventDefault();
        if (confirm("Delete this row?")) {
            var parent = getClosest(event.target, 'tr');
            parent.parentNode.removeChild(parent);
            pmSaveTable();
        }
    }, true);

    //Set onclick of move up button for row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-move-up')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'tr');
        if (parent.previousElementSibling) {
            parent.parentNode.insertBefore(parent, parent.previousElementSibling);
        }
        pmSaveTable();
    }, true);

    //Set onclick of move down button for row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-move-down')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'tr');
        if (parent.nextElementSibling) {
            parent.parentNode.insertBefore(parent.nextElementSibling, parent);
        }
        pmSaveTable();
    }, true);

    //Set onclick of move left button for column
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-move-left')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'td');
        var index = parent.cellIndex;
        var table = getClosest(event.target, 'table');
        var cells = table.querySelectorAll('tr');
        cells.forEach(function (cell) {
            var sc = cell.querySelectorAll("td,th")[index];
            if (sc.previousElementSibling) {
                sc.parentNode.insertBefore(sc, sc.previousElementSibling);
            }
        });
        pmSaveTable();
    }, true);

    //Set onclick of move right button for column
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-move-right')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'td');
        var index = parent.cellIndex;
        var table = getClosest(event.target, 'table');
        var cells = table.querySelectorAll('tr');
        cells.forEach(function (cell) {
            var sc = cell.querySelectorAll("td,th")[index];
            if (sc.nextElementSibling) {
                sc.parentNode.insertBefore(sc.nextElementSibling, sc);
            }
        });
        pmSaveTable();
    }, true);

    //Set onclick of remove left button for column
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmRateTable-delete-col')) {
            return;
        }
        event.preventDefault();
        if (confirm("Delete this column?")) {
            var parent = getClosest(event.target, 'table');
            var cell = getClosest(event.target, 'td');
            var row = parent.rows; // Getting the rows
            var index = cell.cellIndex;
            for (var j = 0; j < row.length; j++) {
                // Deleting the ith cell of each row
                row[j].deleteCell(index);
            }
            pmSaveTable();
        }
    }, true);

    //Set onclick of delete button for CTA row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmrates-delete-cta')) {
            return;
        }
        event.preventDefault();
        if (confirm("Delete this CTA?")) {
            var parent = getClosest(event.target, 'li');
            parent.parentNode.removeChild(parent);
            orderCTAs();
            pmSaveTable();
        }
    }, true);

    //Set onclick of move up button for row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmrates-move-cta-up')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'li');
        if (parent.previousElementSibling) {
            parent.parentNode.insertBefore(parent, parent.previousElementSibling);
        }
        orderCTAs();
        pmSaveTable();
    }, true);

    //Set onclick of move down button for row
    document.addEventListener('click', event => {
        if (!event.target.matches('.pmrates-move-cta-down')) {
            return;
        }
        event.preventDefault();
        var parent = getClosest(event.target, 'li');
        if (parent.nextElementSibling) {
            parent.parentNode.insertBefore(parent.nextElementSibling, parent);
        }
        orderCTAs();
        pmSaveTable();
    }, true);

    // Helper function get closest
    var getClosest = function (elem, selector) {
        // Element.matches() polyfill
        if (!Element.prototype.matches) {
            Element.prototype.matches =
                Element.prototype.matchesSelector ||
                Element.prototype.mozMatchesSelector ||
                Element.prototype.msMatchesSelector ||
                Element.prototype.oMatchesSelector ||
                Element.prototype.webkitMatchesSelector ||
                function (s) {
                    var matches = (this.document || this.ownerDocument).querySelectorAll(s),
                        i = matches.length;
                    while (--i >= 0 && matches.item(i) !== this) { }
                    return i > -1;
                };
        }

        // Get the closest matching element
        for (; elem && elem !== document; elem = elem.parentNode) {
            if (elem.matches(selector)) return elem;
        }
        return null;
    };

    var submitBtns = document.querySelectorAll("#submitdiv button");

    submitBtns.forEach(function(item) {
        item.addEventListener('click', function(event) {
            if(event.target.matches("#submitdiv button")) {
                pmSaveTable();
            } else {
                return;
            }
        });
    });
}
